import java.awt.Color;

import com.collegeboard.gridworld.grid.Location;

public class Hunter extends SpinJumper
{
   private Food myTarget;

   public Hunter(Food targ)
   {
      this(targ, Color.RED);
   }

   public Hunter(Food targ, Color color)
   {
      setTarget(targ);
      setColor(color);
   }

   public Food target()
   {
      return myTarget;
   }

   public void setTarget(Food targ)
   {
      myTarget = targ;
   }

   public void turnTowardTarget()
   {
      int targetDir = getLocation().directionToward(target().getLocation());
      // System.out.println("direction to target " + targetDir);

      while(getDirection() != targetDir)
      {
         turn(45);
      }
      // System.out.println("direction " + getDirection());
   }

   public void turn()
   {
      if(target() != null)
         turnTowardTarget();
      else
         spin();
   }

   public boolean canEat()
   {
      if(target() != null)
      {
         Location forward = getLocation().getNeighborLocation(getDirection());
         return getGrid().get(forward) == target();
      }
      else
      {
         return false;
      }
   }

   public void eat()
   {
      target().removeSelfFromGrid();
      setColor(target().getColor());
      setTarget(null);
   }

   public void act()
   {
      turn();

      if(canEat())
         eat();
      else if(canMoveForward())
         moveForward();
      else if(canJumpForward())
         jumpForward();
   }

}


