import java.awt.Color;
import java.util.Random;

import com.collegeboard.gridworld.grid.Location;
import com.collegeboard.gridworld.actor.Actor;

public class MovingFood extends Food
{
   public MovingFood()
   {
      super(Color.green);
   }

   public MovingFood(Color color)
   {
      super(color);
   }

   public void act()
   {
      if(getGrid() != null) // check to see that this Food has not been eaten
      {
         turn();
         if(canMoveForward())
            moveForward();

         super.act();
      }
   }

   public void moveForward()
   {
      Location forward = getLocation().getNeighborLocation(getDirection());
      moveTo(forward);
   }

   public boolean canMoveForward()
   {
      Location forward = getLocation().getNeighborLocation(getDirection());
      if (!getGrid().isValid(forward))
      {
         return false;
      }
      else
      {
         Actor neighbor = getGrid().get(forward);
         return neighbor == null;
      }
   }

   public void turn()
   {
      Random rand = new Random();

      int degrees = rand.nextInt(8) * Location.HALF_RIGHT;
      turn(degrees);
   }
}