
import java.awt.Color;

import com.collegeboard.gridworld.grid.Location;
import com.collegeboard.gridworld.actor.Actor;

public class SpinJumper extends Spinner
{
   public SpinJumper()
   {
      setColor(Color.RED);
   }

   public SpinJumper(Color color)
   {
      setColor(color);
   }

   public void act()
   {
      if(canMoveForward())
         moveForward();
      else if(canJumpForward())
         jumpForward();
      else
         spin();
   }

   public void jumpForward()
   {
      Location forward = getLocation().getNeighborLocation(getDirection());
      Location twoForward = forward.getNeighborLocation(getDirection());
      moveTo(twoForward);
   }

   public boolean canJumpForward()
   {
      Location forward = getLocation().getNeighborLocation(getDirection());
      Location twoForward = forward.getNeighborLocation(getDirection());
      if (!getGrid().isValid(twoForward))
      {
         return false;
      }
      else
      {
         Actor neighbor = getGrid().get(twoForward);
         return neighbor == null;
      }
   }

}
