
import java.awt.Color;
import java.util.Random;

import com.collegeboard.gridworld.grid.Location;
import com.collegeboard.gridworld.actor.Actor;

public class Spinner extends Actor
{
   public Spinner()
   {
      setColor(Color.RED);
   }

   public Spinner(Color color)
   {
      setColor(color);
   }

   public void act()
   {
      spin();
      if(canMoveForward())
         moveForward();
   }

   public void spin()
   {
      Random rand = new Random();

      int degrees = rand.nextInt(8) * Location.HALF_RIGHT;
      turn(degrees);
   }

   public void moveForward()
   {
      Location forward = getLocation().getNeighborLocation(getDirection());
      moveTo(forward);
   }

   public boolean canMoveForward()
   {
      Location forward = getLocation().getNeighborLocation(getDirection());
      if (!getGrid().isValid(forward))
      {
         return false;
      }
      else
      {
         Actor neighbor = getGrid().get(forward);
         return neighbor == null;
      }
   }

}
