public interface Queue
{
  // postcondition: returns true if queue is empty;
  //                otherwise returns false
  public boolean isEmpty();

  // precondition:  queue is [e1, e2, ..., en] with n >= 0
  // postcondition: queue is [e1, e2, ..., en, item]
  public void enqueue(Object item);

  // precondition:  queue is [e1, e2, ..., en] with n >= 1
  // postcondition: queue is [e2, ..., en]; returns e1
  // exceptions:    throws an unchecked exception if the queue is empty
  public Object dequeue();

  // precondition:  queue is [e1, e2, ..., en] with n >= 1
  // postcondition: queue is unchanged; returns e1
  // exceptions:    throws an unchecked exception if the queue is empty
  public Object peekFront();
}


