public interface Stack
{
  // postcondition: returns true if stack is empty;
  //                otherwise returns false
  public boolean isEmpty();

  // precondition:  stack is [e1, e2, ..., en] with n >= 0
  // postcondition: stack is [e1, e2, ..., en, item]
  public void push(Object item);

  // precondition:  stack is [e1, e2, ..., en] with n >= 1
  // postcondition: stack is [e1, e2, ..., e(n-1)]; returns en
  // exceptions:    throws an unchecked exception if the stack is empty
  public Object pop();

  // precondition:  stack is [e1, e2, ..., en] with n >= 1
  // postcondition: stack is unchanged; returns en
  // exceptions:    throws an unchecked exception if the stack is empty
  public Object peekTop();
}


