import java.awt.Color;
import java.util.ArrayList;

import com.collegeboard.gridworld.actor.Actor;
import com.collegeboard.gridworld.actor.Rock;
import com.collegeboard.gridworld.grid.Location;

public class RockHound extends HonestEater
{
   public RockHound(Color color)
   {
      setColor(color);
   }

   public RockHound() 
   {
      this(Color.ORANGE);
   }

   public boolean eat()
   {
      for (Actor a : getNeighbors()) 
      {
         if (a instanceof Rock)
         {
            a.removeSelfFromGrid();
            return true;
         }
      }
      return false;      
   }
   
   public void move()
   {
      ArrayList<Location> emptyNeighborLocs = getEmptyNeighborLocations();      
      int n = emptyNeighborLocs.size();
       
      if (n > 0)
      {
         Location loc = emptyNeighborLocs.get((int) (n * Math.random()));
         moveTo(loc);      
      }
   }
}
