import java.awt.Color;
import java.util.ArrayList;

import com.collegeboard.gridworld.grid.*;
import com.collegeboard.gridworld.actor.*;

/**
 * 
 * @author Cay Horstmann
 */
public class Boid extends Actor
{
   public Boid()
   {
      int t = (int) (8 * Math.random());
      turn(Location.HALF_LEFT * t);
      setColor(Color.BLUE);
   }
      
   public void act()
   {
      ArrayList<Location> neighbors = getValidNeighborLocations();
      int sum = getDirection();
      int count = 1;
      for (Location nl : neighbors)
      {
         Actor na = getGrid().get(nl);
         if (na != null)
         {
            sum += na.getDirection();
            count++;
         }
      }
      int desiredDirection = sum / count;      

      turn(desiredDirection - getDirection());
      Location next = nextLocation(); 

      if (getGrid().get(next) == null)
      {
         moveTo(next);
      }
      else
      {
         turn(Location.HALF_LEFT);
      }
   }
   
   public Location nextLocation()
   {
      Location next = getLocation().getNeighborLocation(getDirection());
      int rows = getGrid().numRows();
      int cols = getGrid().numCols();
      return new Location((next.row() + rows) % rows, (next.col() + cols) % cols);
   }
}
