import java.util.ArrayList;

import com.collegeboard.gridworld.actor.Actor;
import com.collegeboard.gridworld.grid.Location;

public class Cell extends Actor
{
   public void plan()
   {      
      ArrayList<Location> neighborLocs = getValidNeighborLocations();
      int neighborCount = countOccupiedNeighbors(getLocation());
      die = neighborCount < 2 || neighborCount > 3;
      breedingLocations = new ArrayList<Location>();
      for (Location l : neighborLocs)
      {
         if (countOccupiedNeighbors(l) == 3)
            breedingLocations.add(l);
      }
      planned = true;
   }

   public void act()
   {
      if (!planned) { plan(); return; }
      
      for (Location bl : breedingLocations)
      {
         if (getGrid().get(bl) == null)
            new Cell().putSelfInGrid(getGrid(), bl);
      }
      if (die) removeSelfFromGrid();
      planned = false;
   }

   private int countOccupiedNeighbors(Location loc)
   {      
      int count = 0;
      int d = Location.NORTH;
      for (int i = 0; i < Location.FULL_CIRCLE / Location.HALF_RIGHT; i++)
      {
         Location neighbor = loc.getNeighborLocation(d);
         if (getGrid().isValid(neighbor))
            count++;
         d = d + Location.HALF_RIGHT;
      }
      return count;
   }

   private ArrayList<Location> breedingLocations;
   private boolean die;
   private boolean planned;
}
