import java.awt.Color;
import java.util.ArrayList;

import com.collegeboard.gridworld.actor.Actor;
import com.collegeboard.gridworld.actor.Rock;
import com.collegeboard.gridworld.grid.Grid;
import com.collegeboard.gridworld.grid.Location;

/*
 * Created on Apr 29, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */

public class RockFinder extends Actor
{
   public void act()
   {
      if (rockLocation != null) return; 
   
      Grid<Actor> gr = getGrid();
      ArrayList<Location> nbrs = getValidNeighborLocations();
      ArrayList<Location> emptyNbrs = new ArrayList<Location>();
      for (Location nl : nbrs) 
      {
         Actor nbr = gr.get(nl);
         if (nbr instanceof Rock)
         {
            // we found a rock
            rockLocation = nl;
            setColor(Color.YELLOW);
            return;
         }
         else if (nbr instanceof RockFinder)
         {
            // ask the buddy
            RockFinder buddy = (RockFinder) nbr;
            rockLocation = buddy.getRockLocation();
            if (rockLocation != null)
            {
               setColor(Color.YELLOW);
               return;
            }
         }
         else if (nbr == null)
            emptyNbrs.add(nl);
      }
        
      // no luck--make a buddy
      if (emptyNbrs.size() > 0) 
      {
         RockFinder buddy = new RockFinder();
         buddy.putSelfInGrid(gr, emptyNbrs.get(0));
      }         
   }
   
   public Location getRockLocation() { return rockLocation; }

   private Location rockLocation;
}
