import java.awt.Color;

import com.collegeboard.gridworld.grid.Grid;
import com.collegeboard.gridworld.grid.Location;
import com.collegeboard.gridworld.world.World;

public class TileGame extends World<Tile>
{
   public TileGame()
   {
      Color[] colors = 
         { 
            Color.RED, Color.BLUE, Color.GREEN, Color.CYAN,
            Color.PINK, Color.ORANGE, Color.GRAY, Color.MAGENTA,
            Color.YELLOW
         };
      for (Color color : colors)
      {
         add(new Tile(color));
         add(new Tile(color));
      }
      setMessage("Click on the first tile");
      first = true;
   }

   @Override
   public boolean locationClicked(Location loc)
   {
      Grid<Tile> gr = getGrid();
      Tile t = gr.get(loc);
      if (t != null) 
      { 
         t.flip(); 
         if (first)
         {
            if (firstTile != null) 
            {
               firstTile.flip();
               secondTile.flip();
            }
            firstTile = t;
            setMessage("Click on the second tile");
            first = false;
         }
         else
         {            
            if (firstTile.getColor().equals(t.getColor()))
            {               
               firstTile = secondTile = null; 
            }
            else
               secondTile = t;   
            setMessage("Click on the first tile");
            first = true;
         }                  
      }
      return true;      
   }
   
   public static void main(String[] args)
   {
      new TileGame().show();
   }
   
   private Tile firstTile;
   private Tile secondTile;
   private boolean first;
}
