import com.collegeboard.gridworld.actor.Actor;
import com.collegeboard.gridworld.actor.Rock;
import com.collegeboard.gridworld.grid.Grid;
import com.collegeboard.gridworld.grid.Location;

public class TriangleWalker extends Actor
{
   public TriangleWalker(int size)
   {
      steps = size;
      if (size > 0) buddy = new TriangleWalker(size - 1);
   }
   
   public void act()
   {
      Grid<Actor> gr = getGrid();
      Location loc = getLocation();

      if (buddyLocation == null)
         buddyLocation = loc.getNeighborLocation(Location.NORTH);
      
      if (steps > 0) 
      {
         moveTo(loc.getNeighborLocation(Location.EAST));
         new Rock().putSelfInGrid(gr, loc);
         steps--;         
      }
      else
      {
         if (buddy != null) buddy.putSelfInGrid(gr, buddyLocation);
         removeSelfFromGrid();
      }
   }
   
   private int steps;
   private TriangleWalker buddy;
   private Location buddyLocation;
}
