package com.collegeboard.gridworld.grid;

import java.util.ArrayList;

/**
*  copyright&copy; 2002 College Entrance Examination Board
*  (www.collegeboard.com).
*  copyright&copy; 2005 Cay S. Horstmann (www.horstmann.com)
*  @author Alyce Brady
*  @author APCS Development Committee
*  @author Cay S. Horstmann
 **/

import java.util.*;

public class UnboundedGrid<E> implements Grid<E>
{
    private Map<Location, E> occupantMap;   

    /** Constructs an empty grid
     */
    public UnboundedGrid()
    {
        occupantMap = new HashMap<Location, E>();
    }

    public int numRows()
    {
        return -1;
    }

    public int numCols()
    {
        return -1;
    }
    
    public boolean isValid(Location loc)
    {
       return true;
    }

    public ArrayList<Location> getOccupiedLocations()
    {
       ArrayList<Location> a = new ArrayList<Location>();
  		 a.addAll(occupantMap.keySet());
       return a;
    }

    public E get(Location loc)
    {
      if (loc == null) 
         throw new NullPointerException();
		return occupantMap.get(loc);
    }

    public E put(Location loc, E obj)
    {
       if (loc == null) 
          throw new NullPointerException();
       if (obj == null)
          throw new NullPointerException();
       return occupantMap.put(loc, obj);
    }

    public E remove(Location loc)
    {
       if (loc == null) 
          throw new NullPointerException();
       return occupantMap.remove(loc);
    }
    
    public String toString() { return occupantMap.toString(); } 
}
