package com.collegeboard.gridworld.gui;

import javax.swing.JApplet;
import java.net.URL;
import java.net.URLClassLoader;

/**
 * This class kicks off an applet or application that
 * displays the GridWorld GUI with a simple "starter world".
 *
 *  <p>
 *  copyright&copy; 2005 Cay S. Horstmann (http://horstmann.com)
 *
 * @author Cay Horstmann
 */
public class WorldApplet extends JApplet
{
   public void init()
   {
      try
      {
         URLClassLoader loader = (URLClassLoader) getClass().getClassLoader();
         for (URL url : loader.getURLs())
         {
            if (url.toString().endsWith(".zip"))
            {
               WorldFrame frame = WorldFrame.loadProject(url, loader, null);
               setContentPane(frame.getContentPane());
               setJMenuBar(frame.getJMenuBar());      
               return;
            }
         }
      }
      catch (Exception e)
      {
         showStatus(e.toString());
         e.printStackTrace();
      }
   }
}
